commit da0a5628d47ee59320dac9787f3232b0911fbc14
Author: Segher Boessenkool <segher@kernel.crashing.org>
Date:   Wed Sep 8 15:10:30 2021

    rs6000: Fix ELFv2 r12 use in epilogue
    
    We cannot use r12 here, it is already in use as the GEP (for sibling
    calls).
    
    2021-09-08  Segher Boessenkool  <segher@kernel.crashing.org>
            PR target/102107
            * config/rs6000/rs6000-logue.c (rs6000_emit_epilogue): For ELFv2 use
            r11 instead of r12 for restoring CR.
    
    (cherry picked from commit 86e6268cff328e27ee6f90e2afc35b6f437a25cd)

diff --git a/gcc/config/rs6000/rs6000-logue.c b/gcc/config/rs6000/rs6000-logue.c
index e363d56ecec..9965a8aa691 100644
--- a/gcc/config/rs6000/rs6000-logue.c
+++ b/gcc/config/rs6000/rs6000-logue.c
@@ -4815,6 +4815,10 @@ rs6000_emit_epilogue (enum epilogue_type epilogue_type)
       else if (REGNO (frame_reg_rtx) == 12)
 	cr_save_regno = 11;
 
+      /* For ELFv2 r12 is already in use as the GEP.  */
+      if (DEFAULT_ABI == ABI_ELFv2)
+	cr_save_regno = 11;
+
       cr_save_reg = load_cr_save (cr_save_regno, frame_reg_rtx,
 				  info->cr_save_offset + frame_off,
 				  exit_func);

